=== Utilities/mpi4py/Library/CMakeLists.txt ===
FIND_PACKAGE(MPI)
include(vtkPythonWrapping)

INCLUDE_DIRECTORIES(
  ${MPI_INCLUDE_PATH}
  ${PYTHON_INCLUDE_PATH}
  "${CMAKE_CURRENT_SOURCE_DIR}"
  "${CMAKE_CURRENT_BINARY_DIR}"
  "${CMAKE_CURRENT_SOURCE_DIR}/compat"
  "${CMAKE_CURRENT_BINARY_DIR}/compat"
  "${CMAKE_CURRENT_SOURCE_DIR}/config"
  "${CMAKE_CURRENT_BINARY_DIR}/config"
  )

_vtk_add_python_module(MPIPython MODULE MPI.c)
SET_PROPERTY(TARGET MPIPython PROPERTY PREFIX "")
SET_PROPERTY(TARGET MPIPython PROPERTY LINKER_LANGUAGE CXX)
TARGET_LINK_LIBRARIES(MPIPython ${MPI_C_LIBRARIES} ${PYTHON_LIBRARY})
