=== debian/changelog ===
paraview (3.98.0-1~exp1) experimental; urgency=low

  * [f77524a] Imported Upstream version 3.98.0

 -- Anton Gladky <gladky.anton@gmail.com>  Mon, 03 Dec 2012 23:45:25 +0100

paraview (3.98~rc3-1~exp1) experimental; urgency=low

  * [65ee5c1] Remove qt4-dev-tools from Depends of paraview. 
              Thanks to Torquil Macdonald Sørensen <torquil@gmail.com>
  * [ec2f02b] Imported Upstream version 3.98~rc3
  * [4f57393] Update/remove patches.
  * [e48acbc] Add mpi-default-bin to Build-Depends
  * [2951b8b] Update watch-file. Thanks to Bart Martens <bartm@debian.org>.
  * [100ae82] Remove obselete flag DM-Upload-Allowed.
  * [15fe78e] Override rpath-issue. Seems the problem somewhere 
              in cmake or openmpi.
  * [1feabd0] Install Book.
  * [8a4b47b] Install plugins into the correct place.

 -- Anton Gladky <gladky.anton@gmail.com>  Mon, 26 Nov 2012 19:43:17 +0100

paraview (3.14.1-7) unstable; urgency=low

  [ Anton Gladky ]
  * [fd77b28] Add missing epoch in libavformat-dev version. 
              Thanks to Jakub Wilk. 
              http://lists.debian.org/debian-devel/2012/07/msg00086.html
  * [155d23c] Use compat 9 to harden buildflags.
  * [bdef31b] Add -Wall -pedantic -Wl,--as-needed to buildflags.

  [ Julien Cristau ]
  * [8feb118] Restrict shlibs to depend on the upstream version. 
              (Closes: #680359)

 -- Anton Gladky <gladky.anton@gmail.com>  Fri, 13 Jul 2012 20:56:41 +0200
