=== debian/rules ===
#! /usr/bin/make -f
#export DH_VERBOSE=1

DESTDIR = $(CURDIR)/debian/tmp

UPSTREAM_VERSION = $(shell dpkg-parsechangelog | awk '/^Version:/ { sub("-[^-]*$$", "", $$2); print $$2}')

%:
	dh $@ --with python2 --parallel

export LD_LIBRARY_PATH+=:$(CURDIR)/debian/paraview/usr/lib/paraview

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Explicit settings of MPI_* is required see
# http://www.vtk.org/Bug/view.php?id=12572
PYVER = $(shell pyversions -dv)
extra_flags += -Wno-dev \
	-DBUILD_DOCUMENTATION=ON \
	-DCMAKE_INSTALL_RPATH=/usr/lib/paraview \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH=OFF  \
	-DCMAKE_SKIP_RPATH=OFF \
	-DBUILD_SHARED_LIBS=ON \
	-DVTK_USE_SYSTEM_FREETYPE=ON \
	-DVTK_USE_SYSTEM_JPEG=ON \
	-DVTK_USE_SYSTEM_PNG=ON \
	-DBUILD_TESTING=OFF \
	-DVTK_USE_MPEG2_ENCODER=OFF \
	-DVTK_USE_FFMPEG_ENCODER=ON \
	-DPARAVIEW_ENABLE_FFMPEG=ON \
	-DVTK_HAS_OGGTHEORA_SUPPORT=ON \
	-DVTK_INSTALL_LIBRARY_DIR="lib/paraview" \
	-DVTK_INSTALL_ARCHIVE_DIR="lib/paraview" \
	-DVTK_INSTALL_INCLUDE_DIR="include/paraview" \
	-DVTK_INSTALL_DATA_DIR="share/paraview" \
	-DVTK_INSTALL_DOC_DIR="share/doc/paraview" \
	-DVTK_INSTALL_PACKAGE_DIR="lib/cmake/paraview" \
	-DPV_INSTALL_PLUGIN_DIR="lib/paraview/plugins" \
	-DVTK_CUSTOM_LIBRARY_SUFFIX="" \
	-DVTK_USE_SYSTEM_TIFF=ON \
	-DVTK_USE_SYSTEM_ZLIB=ON \
	-DBUILD_EXAMPLES=OFF \
	-DVTK_USE_SYSTEM_LIBXML2=ON \
	-DVTK_USE_SYSTEM_EXPAT=ON \
	-DDOCUMENTATION_HTML_HELP=ON \
	-DPARAVIEW_INSTALL_DEVELOPMENT_FILES=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DPARAVIEW_USE_MPI=ON \
	-DMPI_INCLUDE_PATH="/usr/include/mpi" \
	-DVTK_USE_SYSTEM_HDF5=ON \
	-DPARAVIEW_ENABLE_PYTHON=ON \
	-DVTK_USE_OGGTHEORA_ENCODER=ON \
	-DVTK_USE_SYSTEM_OGGTHEORA=ON \
	-DPARAVIEW_BUILD_PLUGIN_AdiosReader:BOOL=ON \
	-DPARAVIEW_BUILD_PLUGIN_EyeDomeLighting:BOOL=ON \

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

override_dh_compress:
	dh_compress -X.qch

override_dh_install:
	dh_install --list-missing

override_dh_makeshlibs:
	dh_makeshlibs -V'paraview (>= $(UPSTREAM_VERSION)), paraview (<< $(UPSTREAM_VERSION).)'
